package rocks.zipcode.io.quiz4.collections;

import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 * @author leon on 11/12/2018dd.
 */
public class ComparableTreeSet<T> extends TreeSet implements Comparable {

    private int id;
    private String name;
    private TreeSet<T> customSet = new TreeSet<>();

    public ComparableTreeSet(T... arr) {

        for (T x: arr) {
            customSet.add(x);
        }


    }


    public ComparableTreeSet(int id,String name) {
        this.id = id;
        this.name = name;

    }

    public Integer compareTo(ComparableTreeSet<T> o) {

        if(this.id > o.id ){

            return 1;

        }else if(this.id<o.id){

            return -1;

        }else{
            return 0;
        }
    }

    @Override
    public String toString() {
        return customSet.toString() ;
    }

    @Override
    public int compareTo(Object o) {
        return 0;
    }
}
