package rocks.zipcode.io.quiz4.objectorientation;

import rocks.zipcode.io.quiz4.fundamentals.PalindromeEvaluator;

import java.util.*;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeObject {

    String input = "";


    public PalindromeObject(String input) {
        this.input = input;
    }

    public String[] getAllPalindromes() {
        List<String> list = new ArrayList<String>();


        for(float pivot = 0; pivot < input.length(); pivot += .5){

            float palindromeRadius = pivot - (int) pivot;

            while ((pivot + palindromeRadius)<input.length()&&(pivot - palindromeRadius) >= 0
                    && input.charAt((int)(pivot - palindromeRadius))
                    == input.charAt((int)(pivot + palindromeRadius))){

                list.add(input.substring((int)(pivot - palindromeRadius),
                        (int)(pivot + palindromeRadius + 1)));

                palindromeRadius++;
            }
        }
        Set<String> d  = new HashSet<String>(list);

        return d.toArray(new String[0]);

}

    public Boolean isPalindrome(){
        if(reverseString().equals(input)){
            return true;
        }
        return false;
    }

    public String reverseString() {

        StringBuffer sb = new StringBuffer();
        String str2 = "";
        String in = input.toLowerCase();
        String str = in.substring(0,1).toUpperCase();

        if(input.substring(0,1).equals(in.substring(0,1))){

            sb.append(input);
            sb.reverse();
            str2 = sb.toString();

        }else{
            PalindromeEvaluator.reverseString(str);
            str2 = str + in.substring(1);

        }
        return str2;

     //   String g = str.substring(0,1).toUpperCase() + str.substring(1);

    }
}
